#include "BBBMutexMonitor.h"
#include <iostream>
#include <sstream>
using namespace std;

volatile long BBBMutexMonitor::m_MutexCount(0);

BBBMutexMonitor::BBBMutexMonitor(string mutexname, BOOL interprocess, BOOL useCounter)
{
	ostringstream sTxt;
	long mc=0;

	if (!interprocess) sTxt <<"P"<< GetProcessId(GetCurrentProcess());
	if (useCounter)
		mc = ++BBBMutexMonitor::m_MutexCount;	//kritisk!!!!
												//krver egentlig ogs mutex

	sTxt << "_BBBMutexMonitor_" << mutexname.data() << "_" << mc;

	m_MutexName = sTxt.str();
	cout <<"CreateMutex '"<< m_MutexName.data()<<"'\n";
	m_HandleMutex = CreateMutex(NULL,FALSE,m_MutexName.data());

	if (!m_HandleMutex)
	{
		cout << "Error ved create mutex '" << sTxt.str().data() << "'\n";
		exit(1);
	}
	else if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		cout << "Remark: Mutex fantes i forvejen '" << sTxt.str().data() << "'\n";
		//OpenMutex(....);
	}
}

BBBMutexMonitor::~BBBMutexMonitor(void)
{
	CloseHandle(m_HandleMutex);
	cout << "Mutex '"<< m_MutexName <<"' Closed" << endl;
}

DWORD BBBMutexMonitor::EnterCriticalSection(DWORD waitMilliseconds)
{
	return WaitForSingleObject(m_HandleMutex, waitMilliseconds);
}
void BBBMutexMonitor::ExitCriticalSection()
{
	ReleaseMutex(m_HandleMutex);
}
