#pragma once
#include <windows.h>
#include <process.h>
#include <string.h>
#include <iostream>
using namespace std;

// definition af funktionspointer-type
typedef unsigned (WINAPI *PBEGINTHREADEX_THREADFUNC) (LPVOID lpThreadParameter);
// definition af type for en traad id
typedef unsigned *PBEGINTHREADEX_THREADID;

class BBBThread;

class Runable
{
// Tillad at nedenstende metode tilgr private data/metoder i denne klasse 
friend BBBThread;
public:
	BBBThread *GetThread();
protected:
	virtual	DWORD Run()=0;// pure virtual - objekt-run-metode
private:
	BBBThread *m_pThread;

};


class BBBThread : public Runable
{
public:
	BBBThread(Runable *pRunableObj, const string threadName="");
	virtual ~BBBThread(void);

	void Start();
	void Join(DWORD waitMilliseconds=INFINITE);
	void SetSignalStop();
	BOOL GetStopSignal();
	BOOL IsRunning();
	const string GetName();
	void Suspend();
	void Resume();
	BOOL IsSuspended();

protected:
	Runable *m_pRunObj;			// pointer til Objekt med Run-metode
	HANDLE m_HandleThread;		// funktionspointer - skal vre static-metode
								// derfor ekstra static "binde-metode"
	DWORD m_ThreadId;			// Trdens ID
	string m_ThreadName;		// Navn p Trd
	volatile BOOL m_Stop;		// Til test for sikker afslutning
								// trd m teste jvnligt og
								// selv stoppe hvis false

	// Metoder for brug ved arv fra BBBThread
	BBBThread(const string threadName="");	// for base initiering
	virtual	DWORD Run();// objekt-run-metode
private:
	static DWORD WINAPI	StaticRun(LPVOID param); // skal "binde" til objekt run-metode
	volatile BOOL m_Running;	// Til test for sikker afslutning
								// trd m teste jvnligt og
								// selv stoppe hvis false
	volatile BOOL m_Suspended;	
};


