#include "PHUS_Monitor.h"
#include <iostream>
#include <sstream>

PHUS_Monitor::PHUS_Monitor(int antalPladser)
: BBBMutexMonitor("PHUS",TRUE), 
	m_AntalBiler(0), m_AntalPladser(antalPladser),
	m_Ind_Blocked(FALSE),m_Ud_Blocked(TRUE),
	m_StopMonitor(FALSE),
	m_Delay(10)// sleep hvis fuld/tom ind/ud
{
}

PHUS_Monitor::~PHUS_Monitor(void)
{
}
void PHUS_Monitor::StopMonitor()
{
	m_StopMonitor = TRUE;
}

void PHUS_Monitor::BilKoererInd()
{
	cout << "Start paa bil koerer ind\n";
	EnterCriticalSection();
	cout << "Start paa bil koerer ind - Critical section biler= "
		<< m_AntalBiler <<" pladser "<<m_AntalPladser<<"\n";
	while (m_AntalBiler>=m_AntalPladser)
	{
		cout << "P-hus fuld indkrsel venter\n";
		ExitCriticalSection();
		while (m_Ind_Blocked)
		{
			Sleep(m_Delay);		// vent hvis ikke Plads
			if (m_StopMonitor) return;
		}
		EnterCriticalSection();
	}

	++m_AntalBiler;		// sikker opdatering
	cout << "Bil koert ind nu - der er nu "<<m_AntalBiler<<" biler\n";

	if (m_AntalBiler>=m_AntalPladser)	// Test for fuld
	{
		cout << "P-hus fuld\n";
		m_Ind_Blocked = TRUE;			// Bloker for indkrsel
	}

	m_Ud_Blocked = FALSE;	// der er nu biler og kan kres ud
	ExitCriticalSection();
	cout << "Slut paa bil koerer ind\n";
}

void PHUS_Monitor::BilKoererUd()
{
	cout << "Start paa bil koerer ud\n";
	EnterCriticalSection();
	while (m_AntalBiler<=0)
	{
		cout << "P-hus tomt udkrsel venter\n";
		ExitCriticalSection();
		while (m_Ud_Blocked)
		{
			Sleep(m_Delay);	// vent til der er biler
			if (m_StopMonitor) return;
		}
		EnterCriticalSection();
	}

	--m_AntalBiler;		// sikker opdatering
	cout << "Bil koert ud nu - der er nu "<<m_AntalBiler<<" biler\n";

	if (m_AntalBiler<=0)	// Test for tom
	{
		cout << "P-hus tomt\n";
		m_Ud_Blocked = TRUE;			// Bloker for udkrsel
	}

	m_Ind_Blocked = FALSE;				// der er plads til biler igen
	ExitCriticalSection();
	cout << "Slut paa bil koerer ud\n";
}
